package scripts.roles;

import scripts.*;
import jinro.*;

// Role: Wolf's fortuneteller
// Camp: Wolves

class Wolffortune extends Wolf {
	def static order = 13;
	def static strings = Wolf.strings.attachBundle("roles/Wolffortune.properties");
	def static number = 0;	// All roles must define own "number" property.
	def static bite = true;	// All roles must define own "bite" property.
	def static isInvisible() {
		return true;
	}
	// Returns the proper number.
	def static getJustnumber(number) {
		return 0;
	}
	def getPriority() {
		return 95;
	}
	Wolffortune(actor = null) {
		super(actor);
	}
	def getRoleName() {
		return strings.getString("wolffortune");
	}
	// Calls when start argument/night time.
	def startPhase() {
		super.startPhase();
		switch(JinroGame.time) {
			case 0:
				break;
			case 1:
				notice(strings.getString("notice.divine"));
				break;
		}
	}
	// Returns the actor's command list
	def getCommands(actors) {
		def commands = super.getCommands(actors);
		if(!isLive()) {
			return commands;
		}
		// 0: daytime, 1: nighttime
		switch(JinroGame.time) {
			case 1:
				if(!target) {
					actors.findAll{ it.name != name && it.isLive() }.each {
						commands << strings.getString("command.divine") + "@" + it.name;
					}
				}
				break;
		}
		return commands;
	}
	def receiveMessage(type, target) {
		super.receiveMessage(type, target);
		switch(JinroGame.time) {
			case 0:
				break;
			case 1:
				if(type != strings.getString("command.divine")) {
					return;
				}
				if(this.target) {
					return;
				}
				if(target?.name != name && target?.isLive()) {
					this.target = target;
					notice(strings.getString("notice.divine.target", target.name));
					divine();
				}
				break;
		}
	}
	def divine() {
		target.divined = true;
		notice(strings.getString("notice.divine.result", target.name, JinroGame.getAlias(target.getRoleName())));
		if(target.roleIs(new Fortuneteller())) {
			nextstate = State.recursed;
			countdown = 1;
		}
	}
}
